---

# VARIABLES
variables:
  DOCKER_BUILDKIT: 0
  DOCKER_DRIVER: overlay2
  DOCKER_HOST: tcp://localhost:2375
  DOCKER_TLS_CERTDIR: ""
  GIT_DEPTH: 1

##########################################################################################################

## PIPELINE DEFINITION
stages:
  - check
  - deploy

##########################################################################################################

### COMMON SECTION
.common:
  image: $ANSIBLE_IMAGE
  variables:
    GIT_DEPTH: 1
    ANSIBLE_FORCE_COLOR: "True"
    ANSIBLE_HOST_KEY_CHECKING: "False"
  before_script:
    - eval $(ssh-agent -s); echo "$SSH_PRIVATE_KEY" | tr -d '\r' | ssh-add - > /dev/null
    - mkdir -p ~/.ssh && echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config
    - chmod -R o-w ../

##########################################################################################################

### CHECK SECTION
check:
  extends: .common
  stage: check
  only:
    refs:
      - trunk
  script:
    - echo "Checking inventory"
    - ansible-inventory -i inventory.ini --graph
    - ansible -i inventory.ini -m ping all:\!workstations -u ${USERNAME:-maintenance} || ( test -n "${CHECK_SKIP_ERRORS}" && true )

##########################################################################################################

### DEPLOY SECTION
deploy:
  extends: .common
  stage: deploy
  variables:
    ANSIBLE_STDOUT_CALLBACK: "actionable"
  only:
    refs:
      - master
    variables:
      - $GIT_URL =~ /^\S+$/
  script:
    - echo "Deploying configuration [${GIT_URL}] with parameters [${PARAMETERS}]"
    - export INVENTORY_DIRECTORY="`pwd`"
    - git config --global credential.helper store && echo "https://${GIT_LOGIN}:${GIT_PASSWORD}@$(echo ${GIT_URL} | sed -r 's#([^/])/[^/].*#\1#' | sed -e 's|https://||g')" > ~/.git-credentials
    - mkdir -p /tmp/checkout && git clone "${GIT_URL}" /tmp/checkout && cd /tmp/checkout
    - |
      export ANSIBLE_CONFIG="${INVENTORY_DIRECTORY}/ansible.cfg"
      if [ -s ansible.cfg ]; then
        export ANSIBLE_CONFIG=ansible.cfg
      fi

      if [ -s run.sh ]; then
        sh run.sh
      elif [ -s "${PLAYBOOK:-deploy.yml}" ]; then
        if [ -s requirements.yml ]; then
          ansible-galaxy install -r requirements.yml
        fi
        ansible-playbook ${PARAMETERS} -u ${USERNAME:-maintenance} -i "${INVENTORY_DIRECTORY}/inventory.ini" "${PLAYBOOK:-deploy.yml}"
      else
        echo "Error - no actions available!"
        exit 1
      fi
